Subject: [PATCH v5 5/6] usb: chipidea: let chipidea core device of_node equal's glue layer device of_node

From: [email-masked] (Peter Chen)
Date: Wed, 10 Aug 2016 17:19:30 +0800

On Wed, Aug 10, 2016 at 09:00:15AM +0000, Jun Li wrote:
> Hi, Peter
> 
> > -----Original Message-----
> > From: linux-usb-owner at vger.kernel.org [mailto:linux-usb-
> > owner at vger.kernel.org] On Behalf Of Peter Chen
> > Sent: Wednesday, August 10, 2016 11:12 AM
> > To: Stephen Boyd <[email-masked]>
> > Cc: Peter Chen <[email-masked]>; gregkh at linuxfoundation.org;
> > stern at rowland.harvard.edu; ulf.hansson at linaro.org; broonie at kernel.org;
> > sre at kernel.org; robh+dt at kernel.org; shawnguo at kernel.org;
> > dbaryshkov at gmail.com; dwmw3 at infradead.org; k.kozlowski at samsung.com; linux-
> > arm-kernel at lists.infradead.org; p.zabel at pengutronix.de;
> > devicetree at vger.kernel.org; pawel.moll at arm.com; mark.rutland at arm.com;
> > linux-usb at vger.kernel.org; arnd at arndb.de; s.hauer at pengutronix.de;
> > mail at maciej.szmigiero.name; troy.kisky at boundarydevices.com;
> > festevam at gmail.com; oscar at naiandei.net; linux-pm at vger.kernel.org;
> > stillcompiling at gmail.com; linux-kernel at vger.kernel.org; mka at chromium.org;
> > Peter Chen <[email-masked]>
> > Subject: Re: [PATCH v5 5/6] usb: chipidea: let chipidea core device
> > of_node equal's glue layer device of_node
> > 
> > On Tue, Aug 09, 2016 at 05:15:36PM -0700, Stephen Boyd wrote:
> > > Quoting Peter Chen (2016-08-08 01:52:10)
> > > > From: Peter Chen <[email-masked]>
> > > >
> > > > At device tree, we have no device node for chipidea core, the glue
> > > > layer's node is the parent node for host and udc device. But in
> > > > related driver, the parent device is chipidea core. So, in order to
> > > > let the common driver get parent's node, we let the core's device
> > > > node equals glue layer device node.
> > > >
> > > > Signed-off-by: Peter Chen <[email-masked]>
> > > > Tested-by: Maciej S. Szmigiero <[email-masked]>
> > > > Tested-by Joshua Clayton <[email-masked]>
> > > > ---
> > > >  drivers/usb/chipidea/core.c | 11 +++++++++++
> > > >  1 file changed, 11 insertions(+)
> > > >
> > > > diff --git a/drivers/usb/chipidea/core.c
> > > > b/drivers/usb/chipidea/core.c index 69426e6..b189dc7 100644
> > > > --- a/drivers/usb/chipidea/core.c
> > > > +++ b/drivers/usb/chipidea/core.c
> > > > @@ -954,6 +954,15 @@ static int ci_hdrc_probe(struct platform_device
> > *pdev)
> > > >                 dev_err(dev, "unable to init phy: %d\n", ret);
> > > >                 return ret;
> > > >         }
> > > > +       /*
> > > > +        * At device tree, we have no device node for chipidea core,
> > > > +        * the glue layer's node is the parent node for host and udc
> > > > +        * device. But in related driver, the parent device is
> > chipidea
> > > > +        * core. So, in order to let the common driver get parent's
> > node,
> > > > +        * we let the core's device node equals glue layer's node.
> > > > +        */
> > > > +       if (dev->parent && dev->parent->of_node)
> > > > +               dev->of_node = dev->parent->of_node;
> > >
> > > Can this be done earlier? Perhaps after hw_device_init() in this probe
> > > routine? That would allow me to remove the awkward parent searching in
> > > my ULPI DT awareness patch.
> > 
> > The reason why I locate it there is to avoid "goto label" for error path
> > during PHY's get and initialization operation.
> > 
> > Ok, to simplify your work, I will change it at next version.
> 
> As iommu need this to be done even more earlier, will you consider to
> put it before adding the core's platform device?
> 

I can't do it, it will introduce another issue that the pinctrl has
already requested by parents. The warning is similar like below, but
occurs at the probe.

http://lkml.iu.edu/hypermail/linux/kernel/1607.2/03150.html

I will see how iommu support can be added for platform devices which
are created by runtime (like chipidea core device).

-- 

Best Regards,
Peter Chen